 /*-------------------------------------------------------------------*/
/*  Definicion de las rutinas del modulo de TEOREMAS                 */
/*-------------------------------------------------------------------*/

/*--------  Prototipos de funciones sobre tablas.c   ----------------*/

extern Ptr_tabla vactab (cad12 ident);

extern short esvactab (Ptr_tabla tabla);

extern void adjtab (Ptr_tabla, cad12 sel, nodo_expresion * it);

extern nodo_tabla *loctabizq (Ptr_tabla tabla, cad12 sel);

extern nodo_entrada *loctab (Ptr_tabla tabla, cad12 sel);

extern void elimtab (Ptr_tabla tabla, cad12 sel);


/*-------  Prototipos de funciones de sustitucion.c  ---------------*/

extern short es_variable_exp (nodo_expresion * expr);

extern short es_functor_exp (nodo_expresion * expr);

extern nodo_expresion *copia_exp (nodo_expresion * expr);

extern Ptr_tabla eps (void);

extern void agr (Ptr_tabla sust, cad12 var, nodo_expresion * term);

extern void elim (Ptr_tabla sust, cad12 var);

extern nodo_expresion *apl (nodo_expresion * expr, Ptr_tabla sust,
			    short copia, short *aplico);

extern nodo_expresion *aplr (nodo_expresion * expr, Ptr_tabla sust,
			     short copia);

extern Ptr_tabla umg (nodo_expresion * expr1, nodo_expresion * expr2);

extern Ptr_tabla umg1 (nodo_expresion * expr1, nodo_expresion * expr2);

extern short equal (nodo_expresion * expr1, nodo_expresion * expr2);

/*--------  Prototipos de funciones sobre tablas.c   ----------------*/

extern Ptr_tabla vactab (cad12 ident);

extern short esvactab (Ptr_tabla tabla);

extern void adjtab (Ptr_tabla, cad12 sel, nodo_expresion * it);

extern nodo_tabla *loctabizq (Ptr_tabla tabla, cad12 sel);

extern nodo_entrada *loctab (Ptr_tabla tabla, cad12 sel);

extern void elimtab (Ptr_tabla tabla, cad12 sel);

extern void destruyatab (Ptr_tabla * tabla);


/*-------  Prototipos de funciones de sustitucion.c  ---------------*/

extern short es_variable_exp (nodo_expresion * expr);

extern short es_functor_exp (nodo_expresion * expr);

extern nodo_expresion *copia_exp (nodo_expresion * expr);

extern Ptr_tabla eps (void);

extern void agr (Ptr_tabla sust, cad12 var, nodo_expresion * term);

extern nodo_expresion *apl (nodo_expresion * expr, Ptr_tabla sust,
			    short copia, short *aplico);

extern nodo_expresion *aplr (nodo_expresion * expr, Ptr_tabla sust,
			     short copia);

extern Ptr_tabla umg (nodo_expresion * expr1, nodo_expresion * expr2);

extern Ptr_tabla umg1 (nodo_expresion * expr1, nodo_expresion * expr2);

/*-------  Prototipos de funciones en sistre.c      ----------------*/

extern int existe_regla (nodo_historia * his, nodo_igualdad * r);

extern nodo_expresion *ldr (nodo_igualdad * regla);

extern nodo_expresion *lir (nodo_igualdad * regla);

extern int aplica (nodo_expresion * expri, nodo_expresion * exprd);

extern nodo_expresion *reescribalo
  (nodo_expresion * expr, nodo_igualdad * regla, short *aplico, int *num_if);

extern void fnlo (nodo_expresion * expr, nodo_historia ** prim,
		  nodo_historia ** ult);

/*-------  Prototipos de funciones en rewrite.c      ----------------*/

/* Initialice variables requiered for rewriting */
extern int init_rewriting(char *);

/* Ends the rewriting motor */
void
end_rewriting(void);

/* Finds normal form of an expression using  Leftmost-Outermost rule */
extern
int rewriteOutermost(nodo_expresion ** entexpr, /* Entire expression */
		    nodo_igualdad *special, /* Special rules */
		    int withHistory,       /* true if history is desired */
		    nodo_historia ** hfirst,    /* First in history */
		    nodo_historia ** hlast,     /* Last in history */
		    char *merr);


extern int long_expr (nodo_expresion * expr);

/*-------  Prototipos de funciones en man_teoremas.c    ----------------*/

extern void test_rep(void);

extern void manejar_teoremas (void);

extern void directorio_teoremas (void);

extern void forma_normal (void);

extern void edite_conjeturas (nodo_igualdad ** conj);

extern void conjeturas_no_probadas (void);

extern void conjeturas_probadas (void);

extern void salve_teoremas (void);

extern void escriba_arch (FILE * fp, nodo_demost * dem, int tipo);

extern void escriba_arch_ig (FILE * fp, nodo_igualdad * ig, char *mensaje);

extern void indente (FILE * fp, int sangria);

extern void manejar_teoremas (void);

extern void edite_conjeturas (nodo_igualdad ** conj);

extern void conjeturas (int tipo);

extern void salve_conjeturas (int tipo);

/*-------  Prototipos de funciones en anal_teoremas.c   -------------*/

extern void determine_tipo_teo (cad20 tipo_eq);

extern short analice_conj (FILE * fp, texpr mens_error, texpr str_conjetura,
			   nodo_expresion ** exp);

extern nodo_argum *analice_lista_exp (FILE * fp, texpr mens_error);

extern nodo_igualdad *analice_conjeturas (FILE * fp, texpr mens_error);

extern void normalizar_lista (nodo_argum ** arg, nodo_igualdad ** conj);

extern nodo_expresion *buscar_if (nodo_expresion * expr);

extern int probar_casos (nodo_demost * dem, nodo_expresion * li,
			 nodo_expresion * ld, cad12 nivel);

extern int probar_semantica (nodo_demost * dem, nodo_expresion * li,
			     nodo_expresion * ld, cad12 nivel);

extern int probar_inicial (nodo_tad * t, nodo_expresion * var, nodo_demost * dem,
		     nodo_expresion * li, nodo_expresion * ld, cad12 nivel);

extern int probar_hipotesis (nodo_expresion * li_hip, nodo_expresion * ld_hip,
			     nodo_expresion * var, nodo_expresion * exp,
			     nodo_demost * dem, nodo_expresion * li,
			  nodo_expresion * ld, Ptr_tabla sust, cad12 nivel);

extern int probar_constructora (nodo_tad * t, nodo_expresion * var,
				nodo_demost * dem, nodo_expresion * li,
				nodo_expresion * ld, cad12 nivel);

extern int probar_induccion (nodo_demost * dem,
			     nodo_expresion * li, nodo_expresion * ld,
			     cad12 nivel);

extern void probar_conjeturas (int *ciertas, int *falsas,
			       nodo_igualdad ** conj);

/* 
extern void sustituciones_rep (Ptr_tabla s, nodo_expresion * e,
			       nodo_represent * r);

extern nodo_igualdad *generar_conj_rep (nodo_select * sel, nodo_represent * r);
*/

extern int es_parametro_induccion (nodo_expresion * expr, int pos);

extern void arme_generadora (nodo_expresion ** expr, nodo_generadora * i,
			     cad12 tipo, cad6 clase, cad50 nombre);

extern nodo_argum *buscar_variable_ind (nodo_expresion * expr_li,
					nodo_expresion * expr_ld);

extern void buscar_variable (nodo_argum ** lis,
			     nodo_expresion * expr,
			     nodo_expresion * padre, int pos);

extern void liberar_demost (nodo_demost ** dem);

extern void liberar_conjeturas (nodo_igualdad ** conj);

extern void liberar_historia (nodo_historia ** his);

extern nodo_demost *crear_demost (void);

extern int copiar_demost (nodo_demost **,nodo_demost *,char *);

extern nodo_igualdad *crear_igualdad (nodo_expresion * e1, nodo_expresion * e2);

extern nodo_expresion *crear_expresion (cad12 nombre, cad20 tipo,
					cad6 clase);

extern nodo_historia *crear_historia (nodo_expresion * expr, nodo_igualdad * r,
				      cad12 nivel);

extern void adicionar_nivel (nodo_demost * dem, cad20 nivel, char c);

extern void escriba (texpr cadena);
