 

/***********************************************************/
/* MODULO CON FUNCIONES DEPENDIENTES DEL SISTEMA OPERATIVO */
/* Por Vladimir Tamara                                     */
/***********************************************************/

#ifndef os_dep_h
#define os_dep_h

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include "definic.h"

extern
int copia_archivo (char *fuente, char *destino);
/* Copia el archivo con nombre fuente en destino.  Portable */

extern
nodo_nombre *lista_dir (cad20 dir, cad20 ext,int conext);
/* PROPOSITO:   Retorna una lista con los nombres de los archivos del      *
 *              directorio dir, cuya extension sea ext.                    */
/* VTP. 3/Jun/1997 Se agrego el parametro conext, que indica si
   deben retornarse o no las extensiones */
extern
void nombre_autor (texpr nombre);
/* En UNIX retorna el nombre del usuario del sistema */

extern
void formatear_nombre(texpr lin1, texpr lin2,int conext);
/* Quita via al nombre de archivo que recibe, y opcionalmente
   tambien quita la extension */

extern
int touch (char *nomarc);
/* Actualiza la fecha y hora del archivo nomarc.  Portable */

extern
void transArch (char *nomarc);
/* Convierte el nombre de UNIX al sistema operativo empleado (e.g. DOS) */

extern
void transArch2(char *nomarc);
/* En Cygnus C++ agrega pone nomarc entre comillas, en el resto no cambia */

#ifdef __BORLANDC__
/* Borland C++ 5.0 incluye unlink y chdir como parte de stdio.h */
#include <dir.h>
extern int
strcasecmp (char *,char *);
/* Funcion para comparar dos cadenas sin tener en cuenta capitalizacion */
#else

#include <unistd.h>

#endif

#endif

